<?php
 
$handle = fopen("ins6-log.txt","a");
//DECRYPT THE CB INS NOTIFICATION MESSAGE
$secretKey = "CHANGETHISSTRING"; // secret key from your ClickBank account
 
 
 // get JSON from raw body
$message = json_decode(file_get_contents('php://input'));
// Pull out the encrypted notification and the initialization vector for message, to write to log on webserver
fwrite($handle,'************************JSON*****************************'.PHP_EOL);
fwrite($handle, file_get_contents('php://input'));
 
// AES/CBC/PKCS5Padding decryption
$encrypted = $message->{'notification'};
$iv = $message->{'iv'};
$decrypted = trim(mcrypt_decrypt(MCRYPT_RIJNDAEL_128,
                                 substr(sha1($secretKey), 0, 32),
                                 base64_decode($encrypted),
                                 MCRYPT_MODE_CBC,
                                 base64_decode($iv)), "\0..\32");
 
//fwrite('************************JSON*****************************'.PHP_EOL);
//fwrite(json_encode($decrypted));
//fwrite('******************************************************'.PHP_EOL);
// convert the decrypted string to a JSON object...
$order = json_decode($decrypted);
 
//$objData = serialize( $order);
 
 
/*Each transaction type should be handled differently, as a SALE and a RFND require different activities*/
$txnType = $order->{'transactionType'};
 
 
switch ($txnType) {
    case 'ABANDONED_ORDER':
        //Handle an event for an abandoned cart notification
        processAbandonedCart($order);
        break; 
    case 'SALE':
        //Handle the Sale transaction
        processSale($order);
        break;
    case 'RFND':
        //Handle the RFND Transaction
        processRefund($order);
        break;
    case 'SUBSCRIPTION-CHG':
        //Handle a Subscription Change
        processSubscriptionChange($order);
        break;
    case 'CGBK':
        //Handle a Chargeback
        proccesChargeback($order);
        break;
    case 'BILL':
        //Handle a Billing event
        processBilling($order);
        break;
    case 'INSF':
        //Handle an insufficient funds event
        processInsufficientFunds($order);
        break;
    case 'CANCEL-REBILL':
        //Handle an event that cancels all future rebills
        processCancelRebilling($order);
        break;
    case 'UNCANCEL-REBILL':
        //Handle an event that reinstates an existing subscription for all future rebills
        processUncancelRebilling($order);
        break;
               
    default:
       //Handle a transaction that is not accounted for above, perhaps an alert or log or email that a new transaction type has come through.
        processTransactionDefault($order);
}
 
 
function processSale($order)
{}
function processRefund($order)
{}
function processSubscriptionChange($order)
{}
function proccesChargeback($order)
{}
function processBilling($order)
{}
function processInsufficientFunds($order)
{}
function processCancelRebilling($order)
{}
function processUncancelRebilling($order)
{}
function processAbandonedCart($order)
{}
function processTransactionDefault($order)
{}
 
 
//EXAMPLES OF DATA FROM CB INS
$email = $order->{'customer'}->{'billing'}->{'email'};;
$receipt = $order->{'receipt'};
$fname = $order->{'customer'}->{'billing'}->{'firstName'};
$lname = $order->{'customer'}->{'billing'}->{'lastName'};
$item = $order->{'lineItems'}[0]->{'itemNo'};
if($order->{'lineItems'}[1]) {
    $item = $order->{'lineItems'}[1]->{'itemNo'};
}
$phone = $order->{'customer'}->{'billing'}->{'phoneNumber'};
$vendor = $order->{'vendor'};
$amount = $order->{'totalAccountAmount'};
$txnType = $order->{'transactionType'};
 
fwrite('******************************************************'.PHP_EOL);
fwrite($handle, $txnType . '-'. $receipt .'-'. $item. PHP_EOL);
fwrite($handle,'-----------------------------'. PHP_EOL);
//fwrite($handle, $order);
 
 
 
fwrite($handle, $output);
 
 
fclose($handle);
 
 
?>